require 'yet/valid'
require 'yet/invalid'

module Yet
  module PublicApi
    def valid(value, operations = [])
      Yet::Valid.new(value, operations)
    end

    alias_method :maybe, :valid
    alias_method :is, :valid

    def invalid(value, operations = [])
      Yet::Invalid.new(value, operations)
    end

    alias_method :not, :invalid
    alias_method :is_not, :invalid
  end
end
