require 'yet/base'

module Yet
  class Valid < Base
    def map(&fn)
      new_value = fn.call(@value)

      return new_value if new_value.is_a?(Invalid)

      Yet.valid(new_value)
    end

    def then(&fn) Yet.valid(@value, [*@operations, fn]) end

    def valid?;   true  end
    def invalid?; false end
  end
end
