require 'yet/base'

module Yet
  class Base
    def initialize(value, operations = [])
      @value      = value
      @operations = operations
    end

    def value
      @operations.reduce(self) { |s, fn|
        begin
          s.map(&fn)
        rescue => e
          Yet.is_not(e)
        end
      }.true_value
    end

    def true_value
      @value
    end
  end
end
